/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser.y" /* yacc.c:339  */

/*
 * Copyright 2013 Google Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
/*
 * Author: Author: ncardwell@google.com (Neal Cardwell)
 *
 * This is the parser for the packetdrill script language. It is
 * processed by the bison parser generator.
 *
 * For full documentation see: http://www.gnu.org/software/bison/manual/
 *
 * Here is a quick and dirty tutorial on bison:
 *
 * A bison parser specification is basically a BNF grammar for the
 * language you are parsing. Each rule specifies a nonterminal symbol
 * on the left-hand side and a sequence of terminal symbols (lexical
 * tokens) and or nonterminal symbols on the right-hand side that can
 * "reduce" to the symbol on the left hand side. When the parser sees
 * the sequence of symbols on the right where it "wants" to see a
 * nonterminal on the left, the rule fires, executing the semantic
 * action code in curly {} braces as it reduces the right hand side to
 * the left hand side.
 *
 * The semantic action code for a rule produces an output, which it
 * can reference using the $$ token. The set of possible types
 * returned in output expressions is given in the %union section of
 * the .y file. The specific type of the output for a terminal or
 * nonterminal symbol (corresponding to a field in the %union) is
 * given by the %type directive in the .y file. The action code can
 * access the outputs of the symbols on the right hand side by using
 * the notation $1 for the first symbol, $2 for the second symbol, and
 * so on.
 *
 * The lexer (generated by flex from lexer.l) feeds a stream of
 * terminal symbols up to this parser. Parser semantic actions can
 * access the lexer output for a terminal symbol with the same
 * notation they use for nonterminals.
 *
 * Here's an example rule with its semantic action in {} braces:
 *
 *     tcp_option
 *     ...
 *      | MSS INTEGER   {
 *        $$ = tcp_option_new(...);
 *        ...
 *        $$->data.mss.bytes = htons($2);
 *      }
 *
 * This rule basically says:
 *
 *   When the parser wants to see a tcp_option, if it sees an MSS from
 *   the lexer followed by an INTEGER from the lexer then run the
 *   action code that (a) stores in the output $$ a pointer to a
 *   struct tcp_option object, and then (b) stores in that object the
 *   value of the INTEGER token (accessed with $2).
 *
 */

/* The first part of the .y file consists of C code that bison copies
 * directly into the top of the .c file it generates.
 */

#include "types.h"

#include <arpa/inet.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "gre_packet.h"
#include "ip.h"
#include "ip_packet.h"
#include "icmp_packet.h"
#include "logging.h"
#include "mpls.h"
#include "mpls_packet.h"
#include "tcp_packet.h"
#include "udp_packet.h"
#include "parse.h"
#include "script.h"
#include "tcp.h"
#include "tcp_options.h"

/* This include of the bison-generated .h file must go last so that we
 * can first include all of the declarations on which it depends.
 */
#include "parser.h"

/* Change this YYDEBUG to 1 to get verbose debug output for parsing: */
#define YYDEBUG 0
#if YYDEBUG
extern int yydebug;
#endif

extern FILE *yyin;
extern int yylineno;
extern char *yytext;
extern int yylex(void);
extern int yyparse(void);
extern int yywrap(void);

/* This mutex guards all parser global variables declared in this file. */
pthread_mutex_t parser_mutex = PTHREAD_MUTEX_INITIALIZER;

/* The input to the parser: the path name of the script file to parse. */
static const char* current_script_path = NULL;

/* The starting line number of the input script statement that we're
 * currently parsing. This may be different than yylineno if bison had
 * to look ahead and lexically scan a token on the following line to
 * decide that the current statement is done.
 */
static int current_script_line = -1;

/*
 * We uses this object to look up configuration info needed during
 * parsing (such as whether packets are IPv4 or IPv6).
 */
static const struct config *in_config = NULL;

/* The output of the parser: an output script containing
 * 1) a linked list of options
 * 2) a linked list of events
 */
static struct script *out_script = NULL;

/* The test invocation to pass back to parse_and_finalize_config(). */
struct invocation *invocation;

/* Copy the script contents into our single linear buffer. */
void copy_script(const char *script_buffer, struct script *script)
{
	DEBUGP("copy_script\n");

	free(script->buffer);
	script->length = strlen(script_buffer);
	script->buffer = strdup(script_buffer);
	assert(script->buffer != NULL);

	DEBUGP("copy_script: %d bytes\n", script->length);
}

/* Read the script file into a single linear buffer. */
void read_script(const char *script_path, struct script *script)
{
	int size = 0;

	DEBUGP("read_script(%s)\n", script_path);

	while (script->buffer == NULL) {
		struct stat script_info;
		int fd = -1;

		/* Allocate a buffer big enough for the whole file. */
		if (stat(script_path, &script_info) != 0)
			die("parse error: stat() of script file '%s': %s\n",
			    script_path, strerror(errno));

		/* Pick a buffer size larger than the file, so we'll
		 * know if the file grew.
		 */
		size = max((int)script_info.st_size, size) + 1;

		script->buffer = malloc(size);
		assert(script->buffer != NULL);

		/* Read the file into our buffer. */
		fd = open(script_path, O_RDONLY);
		if (fd < 0)
			die("parse error opening script file '%s': %s\n",
			    script_path, strerror(errno));

		script->length = read(fd, script->buffer, size);
		if (script->length < 0)
			die("parse error reading script file '%s': %s\n",
			    script_path, strerror(errno));

		/* If we filled the buffer, then probably another
		 * process wrote more to the file since our stat call,
		 * so we should try again.
		 */
		if (script->length == size) {
			free(script->buffer);
			script->buffer = NULL;
			script->length = 0;
		}

		if (close(fd))
			die_perror("close");
	}
	DEBUGP("read_script: %d bytes\n", script->length);
}


/* The public entry point for the script parser. Parses the
 * text script file with the given path name and fills in the script
 * object with the parsed representation.
 */
int parse_script(const struct config *config,
			 struct script *script,
			 struct invocation *callback_invocation)
{
	/* This bison-generated parser is not multi-thread safe, so we
	 * have a lock to prevent more than one thread using the
	 * parser at the same time. This is useful in the wire server
	 * context, where in general we may have more than one test
	 * thread running at the same time.
	 */
	if (pthread_mutex_lock(&parser_mutex) != 0)
		die_perror("pthread_mutex_lock");

#if YYDEBUG
	yydebug = 1;
#endif

	/* Now parse the script from our buffer. */
	yyin = fmemopen(script->buffer, script->length, "r");
	if (yyin == NULL)
		die_perror("fmemopen: parse error opening script buffer");

	current_script_path = config->script_path;
	in_config = config;
	out_script = script;
	invocation = callback_invocation;

	/* We have to reset the line number here since the wire server
	 * can do more than one yyparse().
	 */
	yylineno = 1;

	int result = yyparse();		/* invoke bison-generated parser */
	current_script_path = NULL;

	if (fclose(yyin))
		die_perror("fclose: error closing script buffer");

	/* Unlock parser. */
	if (pthread_mutex_unlock(&parser_mutex) != 0)
		die_perror("pthread_mutex_unlock");

	return result ? STATUS_ERR : STATUS_OK;
}

/* Bison emits code to call this method when there's a parse-time error.
 * We print the line number and the error message.
 */
static void yyerror(const char *message)
{
	fprintf(stderr, "%s:%d: parse error at '%s': %s\n",
		current_script_path, yylineno, yytext, message);
}

/* After we finish parsing each line of a script, we analyze the
 * semantics of the line. If we encounter an error then we print the
 * error message to stderr and exit with an error.
 */
static void semantic_error(const char* message)
{
	assert(current_script_line >= 0);
	die("%s:%d: semantic error: %s\n",
	    current_script_path, current_script_line, message);
}

/* This standard callback is invoked by flex when it encounters
 * the end of a file. We return 1 to tell flex to return EOF.
 */
int yywrap(void)
{
	return 1;
}

/* Create and initalize a new expression. */
static struct expression *new_expression(enum expression_t type)
{
	struct expression *expression = calloc(1, sizeof(struct expression));
	expression->type = type;
	return expression;
}

/* Create and initalize a new integer expression with the given
 * literal value and format string.
 */
static struct expression *new_integer_expression(s64 num, const char *format)
{
	struct expression *expression = new_expression(EXPR_INTEGER);
	expression->value.num = num;
	expression->format = format;
	return expression;
}

/* Create and initalize a new one-element expression_list. */
static struct expression_list *new_expression_list(
	struct expression *expression)
{
	struct expression_list *list;
	list = calloc(1, sizeof(struct expression_list));
	list->expression = expression;
	list->next = NULL;
	return list;
}

/* Add the expression to the end of the list. */
static void expression_list_append(struct expression_list *list,
				   struct expression *expression)
{
	while (list->next != NULL) {
		list = list->next;
	}
	list->next = new_expression_list(expression);
}

/* Create and initialize a new option. */
static struct option_list *new_option(char *name, char *value)
{
	struct option_list *opt = calloc(1, sizeof(struct option_list));
	opt->name = name;
	opt->value = value;
	return opt;
}

/* Create and initialize a new event. */
static struct event *new_event(enum event_t type)
{
	struct event *e = calloc(1, sizeof(struct event));
	e->type = type;
	e->time_usecs_end = NO_TIME_RANGE;
	e->offset_usecs = NO_TIME_RANGE;
	return e;
}

static int parse_hex_byte(const char *hex, u8 *byte)
{
	if (!isxdigit((int)hex[0]) || !isxdigit((int)hex[1])) {
		return STATUS_ERR;	/* need two hex digits per byte */
	}
	char buf[] = { hex[0], hex[1], '\0' };
	char* buf_end = NULL;
	u32 byte_value = strtoul(buf, &buf_end, 16);
	assert(byte_value <= 0xff);
	assert(buf_end == buf + 2);
	*byte = byte_value;
	return STATUS_OK;
}

/* Converts a hex string in 'hex' into bytes and stores them in a
 * buffer 'buf' of length 'buf_len' bytes; returns number of bytes in
 * out_len. Works for hex strings of arbitrary size, such as very long
 * TCP Fast Open cookies.
 */
static int parse_hex_string(const char *hex, u8 *buf, int buf_len,
			    int *out_len)
{
	u8 *out = buf;
	u8 *buf_end = buf + buf_len;
	while (hex[0] != '\0') {
		if (out >= buf_end) {
			return STATUS_ERR;	/* ran out of output space */
		}
		if (parse_hex_byte(hex, out))
			return STATUS_ERR;	/* bad character */
		hex += 2;
		out += 1;
	}
	*out_len = out - buf;
	assert(*out_len <= buf_len);
	return STATUS_OK;
}

static struct tcp_option *new_tcp_fast_open_option(const char *cookie_string,
						    char **error)
{
	int cookie_string_len = strlen(cookie_string);
	if (cookie_string_len & 1) {
		asprintf(error,
			 "TCP fast open cookie has an odd number of digits");
		return NULL;
	}
	int cookie_bytes = cookie_string_len / 2;  /* 2 hex chars per byte */
	if (cookie_bytes > MAX_TCP_FAST_OPEN_COOKIE_BYTES) {
		asprintf(error, "TCP fast open cookie too long");
		asprintf(error, "TCP fast open cookie of %d bytes "
			 "exceeds maximum cookie length of %d bytes",
			 cookie_bytes, MAX_TCP_FAST_OPEN_COOKIE_BYTES);
		return NULL;
	}
	u8 option_bytes = TCPOLEN_EXP_FASTOPEN_BASE + cookie_bytes;
	struct tcp_option *option;
	option = tcp_option_new(TCPOPT_EXP, option_bytes);
	option->data.fast_open.magic = htons(TCPOPT_FASTOPEN_MAGIC);
	int parsed_bytes = 0;
	/* Parse cookie. This should be an ASCII hex string
	 * representing an even number of bytes (4-16 bytes). But we
	 * do not enforce this, since we want to allow test cases that
	 * supply invalid cookies.
	 */
	if (parse_hex_string(cookie_string, option->data.fast_open.cookie,
			     sizeof(option->data.fast_open.cookie),
			     &parsed_bytes)) {
		free(option);
		asprintf(error,
			 "TCP fast open cookie is not a valid hex string");
		return NULL;
	}
	assert(parsed_bytes == cookie_bytes);
	return option;
}


#line 498 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ELLIPSIS = 258,
    SA_FAMILY = 259,
    SIN_PORT = 260,
    SIN_ADDR = 261,
    _HTONS_ = 262,
    INET_ADDR = 263,
    MSG_NAME = 264,
    MSG_IOV = 265,
    MSG_FLAGS = 266,
    FD = 267,
    EVENTS = 268,
    REVENTS = 269,
    ONOFF = 270,
    LINGER = 271,
    ACK = 272,
    ECR = 273,
    EOL = 274,
    MSS = 275,
    NOP = 276,
    SACK = 277,
    SACKOK = 278,
    TIMESTAMP = 279,
    VAL = 280,
    WIN = 281,
    WSCALE = 282,
    PRO = 283,
    FAST_OPEN = 284,
    ECT0 = 285,
    ECT1 = 286,
    CE = 287,
    ECT01 = 288,
    NO_ECN = 289,
    IPV4 = 290,
    IPV6 = 291,
    ICMP = 292,
    UDP = 293,
    GRE = 294,
    MTU = 295,
    MPLS = 296,
    LABEL = 297,
    TC = 298,
    TTL = 299,
    OPTION = 300,
    FLOAT = 301,
    INTEGER = 302,
    HEX_INTEGER = 303,
    WORD = 304,
    STRING = 305,
    BACK_QUOTED = 306,
    CODE = 307,
    IPV4_ADDR = 308,
    IPV6_ADDR = 309
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 438 "parser.y" /* yacc.c:355  */

	s64 integer;
	double floating;
	char *string;
	char *reserved;
	s64 time_usecs;
	enum direction_t direction;
	enum ip_ecn_t ip_ecn;
	struct mpls_stack *mpls_stack;
	struct mpls mpls_stack_entry;
	u16 port;
	s32 window;
	u32 sequence_number;
	struct {
		int protocol;		/* IPPROTO_TCP or IPPROTO_UDP */
		u32 start_sequence;
		u16 payload_bytes;
	} tcp_sequence_info;
	struct option_list *option;
	struct event *event;
	struct packet *packet;
	struct syscall_spec *syscall;
	struct command_spec *command;
	struct code_spec *code;
	struct tcp_option *tcp_option;
	struct tcp_options *tcp_options;
	struct expression *expression;
	struct expression_list *expression_list;
	struct errno_spec *errno_info;

#line 624 "parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 655 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   255

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  72
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  63
/* YYNRULES -- Number of rules.  */
#define YYNRULES  138
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  274

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   309

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      59,    60,    57,    56,    63,    68,    67,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      66,    55,    61,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    64,     2,    65,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,    69,    71,    58,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   520,   520,   526,   530,   537,   541,   548,   553,   557,
     558,   559,   560,   561,   562,   563,   567,   568,   572,   576,
     581,   588,   617,   623,   629,   634,   641,   651,   657,   666,
     667,   668,   669,   673,   674,   675,   679,   707,   728,   749,
     753,   764,   775,   782,   795,   798,   807,   823,   824,   833,
     837,   838,   843,   848,   853,   859,   860,   864,   865,   869,
     870,   874,   875,   876,   877,   878,   882,   883,   884,   885,
     889,   910,   911,   920,   921,   930,   931,   932,   936,   942,
     951,   952,   956,   957,   961,   962,   963,   970,   977,   981,
     984,   998,  1011,  1012,  1027,  1041,  1054,  1055,  1059,  1063,
    1064,  1068,  1069,  1073,  1076,  1077,  1078,  1082,  1087,  1092,
    1095,  1098,  1101,  1104,  1107,  1110,  1113,  1119,  1125,  1131,
    1143,  1147,  1154,  1161,  1193,  1209,  1219,  1230,  1231,  1235,
    1243,  1244,  1252,  1253,  1257,  1261,  1262,  1266,  1274
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ELLIPSIS", "SA_FAMILY", "SIN_PORT",
  "SIN_ADDR", "_HTONS_", "INET_ADDR", "MSG_NAME", "MSG_IOV", "MSG_FLAGS",
  "FD", "EVENTS", "REVENTS", "ONOFF", "LINGER", "ACK", "ECR", "EOL", "MSS",
  "NOP", "SACK", "SACKOK", "TIMESTAMP", "VAL", "WIN", "WSCALE", "PRO",
  "FAST_OPEN", "ECT0", "ECT1", "CE", "ECT01", "NO_ECN", "IPV4", "IPV6",
  "ICMP", "UDP", "GRE", "MTU", "MPLS", "LABEL", "TC", "TTL", "OPTION",
  "FLOAT", "INTEGER", "HEX_INTEGER", "WORD", "STRING", "BACK_QUOTED",
  "CODE", "IPV4_ADDR", "IPV6_ADDR", "'='", "'+'", "'*'", "'~'", "'('",
  "')'", "'>'", "':'", "','", "'['", "']'", "'<'", "'.'", "'-'", "'|'",
  "'{'", "'}'", "$accept", "script", "opt_options", "options", "option",
  "option_flag", "option_value", "opt_init_command", "init_command",
  "events", "event", "event_time", "time", "action", "packet_spec",
  "tcp_packet_spec", "udp_packet_spec", "icmp_packet_spec",
  "packet_prefix", "mpls_stack", "mpls_stack_entry",
  "opt_mpls_stack_bottom", "icmp_type", "opt_icmp_code", "opt_icmp_echoed",
  "opt_icmp_mtu", "direction", "opt_ip_info", "ip_ecn", "flags", "seq",
  "opt_ack", "opt_window", "opt_tcp_options", "tcp_option_list",
  "opt_tcp_fast_open_cookie", "tcp_fast_open_cookie", "tcp_option",
  "sack_block_list", "sack_block", "syscall_spec", "opt_end_time",
  "function_name", "function_arguments", "expression_list", "expression",
  "decimal_integer", "hex_integer", "binary_expression", "array", "inaddr",
  "sockaddr", "msghdr", "iovec", "pollfd", "opt_revents", "linger",
  "opt_errno", "opt_note", "note", "word_list", "command_spec",
  "code_spec", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,    61,    43,    42,   126,    40,
      41,    62,    58,    44,    91,    93,    60,    46,    45,   124,
     123,   125
};
# endif

#define YYPACT_NINF -155

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-155)))

#define YYTABLE_NINF -53

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -36,  -155,     4,   -32,   -36,  -155,   -18,  -155,  -155,    67,
    -155,  -155,  -155,    50,  -155,  -155,    19,  -155,    67,  -155,
       9,   -13,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
      14,  -155,    19,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,    43,  -155,  -155,    34,  -155,  -155,    19,    31,  -155,
      40,    44,    35,    39,  -155,    58,    65,   -41,  -155,    53,
    -155,    19,    54,    56,    71,  -155,   -42,  -155,  -155,  -155,
    -155,  -155,    61,    59,    66,    69,    83,    72,  -155,  -155,
      89,    -1,    85,  -155,    88,    84,    82,   101,  -155,  -155,
      97,    98,  -155,  -155,  -155,    99,  -155,   129,  -155,    90,
    -155,  -155,  -155,   144,  -155,     3,   107,   -35,    86,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,     7,
      91,    92,  -155,   104,    96,    93,  -155,   117,   111,   133,
     110,  -155,  -155,   -22,   100,   109,   102,   112,   113,  -155,
       7,     7,   -46,  -155,  -155,   103,   105,   115,   118,  -155,
    -155,   122,   108,   116,  -155,   124,   123,   170,     7,   128,
      86,    86,   119,   119,   134,  -155,   120,  -155,  -155,    11,
    -155,  -155,   114,   121,   126,   -45,   125,   130,  -155,  -155,
    -155,   135,  -155,   131,  -155,   136,  -155,   140,  -155,   156,
     142,    15,    13,  -155,  -155,   185,   138,   178,   179,  -155,
     -44,   137,  -155,  -155,   132,   140,  -155,   149,  -155,  -155,
    -155,  -155,  -155,  -155,   106,   143,   194,   146,   147,  -155,
    -155,   139,   152,  -155,   186,  -155,   198,   145,     7,   159,
     158,   165,  -155,   163,   153,   201,   -27,   148,   150,   166,
    -155,   167,   157,   203,   151,  -155,   155,   160,   161,   124,
     168,  -155,  -155,  -155,   162,   164,     7,   220,   172,    86,
     173,   169,   221,   171,   176,   219,   181,   177,   180,     7,
     174,    37,  -155,  -155
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     8,     0,    16,     4,     5,     0,     1,   137,     0,
      17,    18,     6,     0,    27,    28,     0,    24,     2,    19,
      96,    23,    14,    15,     9,    10,    11,    12,    13,     7,
      22,    20,     0,   138,    58,    57,    21,    29,    33,    34,
      35,    59,    39,    30,     0,    31,    32,     0,     0,    97,
       0,     0,     0,     0,    44,     0,     0,     0,    98,     0,
      25,     0,     0,     0,     0,    42,     0,    62,    63,    65,
      64,    61,     0,     0,     0,     0,     0,    66,    67,    69,
       0,     0,     0,    26,     0,     0,     0,     0,    43,    45,
       0,     0,    60,    54,    49,    50,    68,    71,   103,     0,
     117,   118,   106,   107,    99,     0,     0,     0,   101,   104,
     105,   109,   110,   111,   112,   113,   114,   115,   116,     0,
       0,     0,    37,     0,     0,     0,    51,    55,     0,    73,
       0,   108,   120,     0,     0,     0,     0,     0,     0,   100,
       0,     0,   130,    40,    41,     0,     0,     0,     0,    38,
      72,     0,    75,     0,   121,     0,     0,     0,     0,     0,
     102,   119,     0,   132,     0,    53,     0,    56,    74,     0,
      36,   122,     0,     0,     0,     0,     0,     0,   131,    95,
     133,     0,    70,     0,    85,     0,    84,     0,    88,     0,
       0,    80,     0,    78,   125,     0,     0,     0,     0,   135,
       0,     0,    77,    86,     0,    89,    92,     0,    87,    83,
      82,    91,    81,    76,     0,     0,     0,     0,     0,   136,
     134,    47,     0,    93,     0,    79,     0,     0,     0,     0,
       0,     0,    94,     0,     0,     0,   127,     0,     0,     0,
      90,     0,     0,     0,     0,   129,     0,     0,     0,     0,
       0,   126,    48,    46,     0,     0,     0,     0,     0,   128,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   123,   124
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -155,  -155,  -155,  -155,   232,  -155,  -155,  -155,  -155,  -155,
     223,  -155,    -3,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,
     175,  -155,  -155,  -155,  -155,  -155,  -155,    23,  -155,    33,
    -155,  -155,  -155,  -155,   141,  -119,  -154,  -155,  -155,   -19,
    -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,  -155,    76,
    -155,   224,  -155
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,     5,     6,    29,     9,    10,    18,
      19,    20,    21,    36,    37,    38,    39,    40,    41,    66,
      89,   231,    95,   127,    56,   149,    42,    57,    74,    80,
      75,   129,   152,   170,   192,   211,   212,   193,   205,   206,
      43,    44,    59,    82,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   244,   118,   163,   179,   178,
     200,    11,    46
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     142,   172,    98,   162,     7,   219,    98,    99,    77,     1,
      98,    99,    32,    30,   183,    99,   220,    87,   197,     8,
      88,   160,   161,   141,   141,   139,    78,    79,   140,    49,
     184,   185,   186,   187,   188,   189,   243,    13,   190,   175,
     191,   140,   141,   154,    60,    47,   100,   101,   102,   103,
     100,   101,   102,   103,   100,   101,   102,   103,    83,   104,
       8,    33,   209,   105,   210,    14,    15,   105,   132,   106,
      34,   105,    48,   106,   213,    35,   214,   106,    50,    51,
     -52,    52,    53,    58,    54,    22,    23,    61,    67,    68,
      69,    70,    71,    62,    64,   255,    72,    24,    63,    25,
      26,    65,    76,    27,    28,    73,   141,    55,   273,   236,
     134,   135,    81,    14,    15,    84,   136,    85,    86,   137,
      90,    91,   138,    16,    17,   184,   185,   186,   187,   188,
     189,    92,    94,   190,    93,   191,    73,   259,   121,    96,
     119,   120,   122,   123,   124,   125,   128,   131,   126,   130,
     271,   145,   147,   143,   144,   141,   146,   148,   150,   151,
     153,   157,   166,   155,   156,   167,   164,   158,   159,   168,
     165,   100,   173,   174,   169,   176,   171,   181,   177,   199,
     182,   207,   201,   203,   195,   194,   196,   204,   198,   208,
     215,   217,   202,   216,   222,   218,   224,   227,   226,   232,
     221,   228,   229,   230,   233,   234,   237,   238,   235,   239,
     240,   242,   241,   247,   248,   246,   249,   250,   252,   245,
     253,   254,   251,   256,   258,   257,   260,   261,   262,   264,
     267,   268,   269,   105,   265,   266,    12,   225,   223,   180,
     270,    31,   263,     0,    45,   272,   133,     0,     0,     0,
       0,     0,     0,     0,     0,    97
};

static const yytype_int16 yycheck[] =
{
     119,   155,     3,    49,     0,    49,     3,     8,    49,    45,
       3,     8,     3,    16,     3,     8,    60,    59,    63,    51,
      62,   140,   141,    69,    69,    60,    67,    68,    63,    32,
      19,    20,    21,    22,    23,    24,    63,    55,    27,   158,
      29,    63,    69,    65,    47,    58,    47,    48,    49,    50,
      47,    48,    49,    50,    47,    48,    49,    50,    61,    60,
      51,    52,    47,    64,    49,    46,    47,    64,    65,    70,
      61,    64,    58,    70,    61,    66,    63,    70,    35,    36,
      37,    38,    39,    49,    41,    35,    36,    56,    30,    31,
      32,    33,    34,    53,    59,   249,    38,    47,    54,    49,
      50,    62,    37,    53,    54,    47,    69,    64,    71,   228,
       3,     4,    59,    46,    47,    61,     9,    61,    47,    12,
      59,    62,    15,    56,    57,    19,    20,    21,    22,    23,
      24,    65,    49,    27,    65,    29,    47,   256,    54,    67,
      55,    53,    60,    42,    47,    47,    17,     3,    49,    59,
     269,    47,    59,    62,    62,    69,    60,    40,    47,    26,
      50,    59,    47,    63,    55,    47,    63,    55,    55,    47,
      65,    47,    49,     3,    66,    47,    60,    43,    59,    49,
      60,    25,    47,    47,    63,    71,    60,    47,    63,    47,
       5,    13,    61,    55,    62,    16,    47,     3,    55,    47,
      63,    55,    55,    64,    18,     7,    47,    49,    63,    44,
      47,    10,    59,    47,    47,    65,    59,    14,    63,    71,
      60,    60,    71,    55,    60,    63,     6,    55,    55,     8,
      11,    50,    55,    64,    63,    59,     4,   214,   205,   163,
      60,    18,   261,    -1,    20,    71,   105,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    80
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    45,    73,    74,    75,    76,    77,     0,    51,    79,
      80,   133,    76,    55,    46,    47,    56,    57,    81,    82,
      83,    84,    35,    36,    47,    49,    50,    53,    54,    78,
      84,    82,     3,    52,    61,    66,    85,    86,    87,    88,
      89,    90,    98,   112,   113,   133,   134,    58,    58,    84,
      35,    36,    38,    39,    41,    64,    96,    99,    49,   114,
      84,    56,    53,    54,    59,    62,    91,    30,    31,    32,
      33,    34,    38,    47,   100,   102,    37,    49,    67,    68,
     101,    59,   115,    84,    61,    61,    47,    59,    62,    92,
      59,    62,    65,    65,    49,    94,    67,   102,     3,     8,
      47,    48,    49,    50,    60,    64,    70,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   128,    55,
      53,    54,    60,    42,    47,    47,    49,    95,    17,   103,
      59,     3,    65,   116,     3,     4,     9,    12,    15,    60,
      63,    69,   117,    62,    62,    47,    60,    59,    40,    97,
      47,    26,   104,    50,    65,    63,    55,    59,    55,    55,
     117,   117,    49,   129,    63,    65,    47,    47,    47,    66,
     105,    60,   118,    49,     3,   117,    47,    59,   131,   130,
     131,    43,    60,     3,    19,    20,    21,    22,    23,    24,
      27,    29,   106,   109,    71,    63,    60,    63,    63,    49,
     132,    47,    61,    47,    47,   110,   111,    25,    47,    47,
      49,   107,   108,    61,    63,     5,    55,    13,    16,    49,
      60,    63,    62,   111,    47,   109,    55,     3,    55,    55,
      64,    93,    47,    18,     7,    63,   117,    47,    49,    44,
      47,    59,    10,    63,   127,    71,    65,    47,    47,    59,
      14,    71,    63,    60,    60,   118,    55,    63,    60,   117,
       6,    55,    55,   121,     8,    63,    59,    11,    50,    55,
      60,   117,    71,    71
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    72,    73,    74,    74,    75,    75,    76,    77,    78,
      78,    78,    78,    78,    78,    78,    79,    79,    80,    81,
      81,    82,    83,    83,    83,    83,    83,    84,    84,    85,
      85,    85,    85,    86,    86,    86,    87,    88,    89,    90,
      90,    90,    90,    90,    91,    91,    92,    93,    93,    94,
      95,    95,    96,    96,    96,    97,    97,    98,    98,    99,
      99,   100,   100,   100,   100,   100,   101,   101,   101,   101,
     102,   103,   103,   104,   104,   105,   105,   105,   106,   106,
     107,   107,   108,   108,   109,   109,   109,   109,   109,   109,
     109,   109,   110,   110,   111,   112,   113,   113,   114,   115,
     115,   116,   116,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   117,   117,   117,   117,   118,   119,   120,
     121,   121,   122,   123,   124,   125,   126,   127,   127,   128,
     129,   129,   130,   130,   131,   132,   132,   133,   134
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     1,     1,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       2,     2,     2,     1,     1,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     5,     6,     1,
       6,     6,     3,     4,     0,     2,    11,     0,     4,     1,
       0,     1,     0,     6,     3,     0,     2,     1,     1,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       6,     0,     2,     0,     2,     0,     3,     3,     1,     3,
       0,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       5,     2,     1,     2,     3,     7,     0,     2,     1,     2,
       3,     1,     3,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       2,     3,     4,    19,    19,     5,    10,     0,     4,     9,
       0,     2,     0,     1,     3,     1,     2,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 520 "parser.y" /* yacc.c:1646  */
    {
	(yyval.string) = NULL;		/* The parser output is in out_script */
}
#line 2033 "parser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 526 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = NULL;
	parse_and_finalize_config(invocation);
}
#line 2042 "parser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 530 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = (yyvsp[0].option);
	parse_and_finalize_config(invocation);
}
#line 2051 "parser.c" /* yacc.c:1646  */
    break;

  case 5:
#line 537 "parser.y" /* yacc.c:1646  */
    {
	out_script->option_list = (yyvsp[0].option);
	(yyval.option) = (yyvsp[0].option);		/* return the tail so we can append to it */
}
#line 2060 "parser.c" /* yacc.c:1646  */
    break;

  case 6:
#line 541 "parser.y" /* yacc.c:1646  */
    {
	(yyvsp[-1].option)->next = (yyvsp[0].option);
	(yyval.option) = (yyvsp[0].option);		/* return the tail so we can append to it */
}
#line 2069 "parser.c" /* yacc.c:1646  */
    break;

  case 7:
#line 548 "parser.y" /* yacc.c:1646  */
    {
	(yyval.option) = new_option((yyvsp[-2].string), (yyvsp[0].string));
}
#line 2077 "parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 553 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].reserved); }
#line 2083 "parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 557 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(yytext); }
#line 2089 "parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 558 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2095 "parser.c" /* yacc.c:1646  */
    break;

  case 11:
#line 559 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2101 "parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 560 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2107 "parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 561 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2113 "parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 562 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("ipv4"); }
#line 2119 "parser.c" /* yacc.c:1646  */
    break;

  case 15:
#line 563 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("ipv6"); }
#line 2125 "parser.c" /* yacc.c:1646  */
    break;

  case 16:
#line 567 "parser.y" /* yacc.c:1646  */
    { }
#line 2131 "parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 568 "parser.y" /* yacc.c:1646  */
    { }
#line 2137 "parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 572 "parser.y" /* yacc.c:1646  */
    { out_script->init_command = (yyvsp[0].command); }
#line 2143 "parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 576 "parser.y" /* yacc.c:1646  */
    {
	out_script->event_list = (yyvsp[0].event);  /* save pointer to event list as output
				       * of parser */
	(yyval.event) = (yyvsp[0].event);          /* return the tail so that we can append to it */
}
#line 2153 "parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 581 "parser.y" /* yacc.c:1646  */
    {
	(yyvsp[-1].event)->next = (yyvsp[0].event);    /* link new event to the end of the existing list */
	(yyval.event) = (yyvsp[0].event);          /* return the tail so that we can append to it */
}
#line 2162 "parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 588 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = (yyvsp[0].event);
	(yyval.event)->line_number = (yyvsp[-1].event)->line_number;   /* use timestamp's line */
	(yyval.event)->time_usecs  = (yyvsp[-1].event)->time_usecs;
	(yyval.event)->time_usecs_end  = (yyvsp[-1].event)->time_usecs_end;
	(yyval.event)->time_type = (yyvsp[-1].event)->time_type;

	if ((yyval.event)->time_usecs_end != NO_TIME_RANGE) {
		if ((yyval.event)->time_usecs_end < (yyval.event)->time_usecs)
			semantic_error("time range is backwards");
	}
	if ((yyval.event)->time_type == ANY_TIME &&  ((yyval.event)->type != PACKET_EVENT ||
	    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time <star> can only be used with "
			       "outbound packets");
	} else if (((yyval.event)->time_type == ABSOLUTE_RANGE_TIME ||
		    (yyval.event)->time_type == RELATIVE_RANGE_TIME) &&
	           ((yyval.event)->type != PACKET_EVENT ||
		    packet_direction((yyval.event)->event.packet) != DIRECTION_OUTBOUND)) {
		yylineno = (yyval.event)->line_number;
		semantic_error("event time range can only be used with "
			       "outbound packets");
	}
	free((yyvsp[-1].event));
}
#line 2193 "parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 617 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_usecs = (yyvsp[0].time_usecs);
	(yyval.event)->time_type = RELATIVE_TIME;
}
#line 2204 "parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 623 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_usecs = (yyvsp[0].time_usecs);
	(yyval.event)->time_type = ABSOLUTE_TIME;
}
#line 2215 "parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 629 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[0]).first_line;
	(yyval.event)->time_type = ANY_TIME;
}
#line 2225 "parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 634 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[-2]).first_line;
	(yyval.event)->time_type = ABSOLUTE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[-2].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[0].time_usecs);
}
#line 2237 "parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 641 "parser.y" /* yacc.c:1646  */
    {
	(yyval.event) = new_event(INVALID_EVENT);
	(yyval.event)->line_number = (yylsp[-4]).first_line;
	(yyval.event)->time_type = RELATIVE_RANGE_TIME;
	(yyval.event)->time_usecs = (yyvsp[-3].time_usecs);
	(yyval.event)->time_usecs_end = (yyvsp[0].time_usecs);
}
#line 2249 "parser.c" /* yacc.c:1646  */
    break;

  case 27:
#line 651 "parser.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].floating) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[0].floating) * 1.0e6); /* convert float secs to s64 microseconds */
}
#line 2260 "parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 657 "parser.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].integer) < 0) {
		semantic_error("negative time");
	}
	(yyval.time_usecs) = (s64)((yyvsp[0].integer) * 1000000); /* convert int secs to s64 microseconds */
}
#line 2271 "parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 666 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(PACKET_EVENT);  (yyval.event)->event.packet  = (yyvsp[0].packet); }
#line 2277 "parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 667 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(SYSCALL_EVENT); (yyval.event)->event.syscall = (yyvsp[0].syscall); }
#line 2283 "parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 668 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(COMMAND_EVENT); (yyval.event)->event.command = (yyvsp[0].command); }
#line 2289 "parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 669 "parser.y" /* yacc.c:1646  */
    { (yyval.event) = new_event(CODE_EVENT);    (yyval.event)->event.code    = (yyvsp[0].code); }
#line 2295 "parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 673 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2301 "parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 674 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2307 "parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 675 "parser.y" /* yacc.c:1646  */
    { (yyval.packet) = (yyvsp[0].packet); }
#line 2313 "parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 679 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-6].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (((yyvsp[0].tcp_options) == NULL) && (direction != DIRECTION_OUTBOUND)) {
		yylineno = (yylsp[0]).first_line;
		semantic_error("<...> for TCP options can only be used with "
			       "outbound packets");
	}

	inner = new_tcp_packet(in_config->wire_protocol,
			       direction, (yyvsp[-5].ip_ecn), (yyvsp[-4].string),
			       (yyvsp[-3].tcp_sequence_info).start_sequence, (yyvsp[-3].tcp_sequence_info).payload_bytes,
			       (yyvsp[-2].sequence_number), (yyvsp[-1].window), (yyvsp[0].tcp_options), &error);
	free((yyvsp[-4].string));
	free((yyvsp[0].tcp_options));
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2343 "parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 707 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-4].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	if (!is_valid_u16((yyvsp[-1].integer))) {
		semantic_error("UDP payload size out of range");
	}

	inner = new_udp_packet(in_config->wire_protocol, direction, (yyvsp[-1].integer), &error);
	if (inner == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2366 "parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 728 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *outer = (yyvsp[-5].packet), *inner = NULL;
	enum direction_t direction = outer->direction;

	inner = new_icmp_packet(in_config->wire_protocol, direction, (yyvsp[-2].string), (yyvsp[-1].string),
				(yyvsp[-4].tcp_sequence_info).protocol, (yyvsp[-4].tcp_sequence_info).start_sequence,
				(yyvsp[-4].tcp_sequence_info).payload_bytes, (yyvsp[0].integer), &error);
	free((yyvsp[-2].string));
	free((yyvsp[-1].string));
	if (inner == NULL) {
		semantic_error(error);
		free(error);
	}

	(yyval.packet) = packet_encapsulate_and_free(outer, inner);
}
#line 2388 "parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 749 "parser.y" /* yacc.c:1646  */
    {
	(yyval.packet) = packet_new(PACKET_MAX_HEADER_BYTES);
	(yyval.packet)->direction = (yyvsp[0].direction);
}
#line 2397 "parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 753 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-5].packet);
	char *ip_src = (yyvsp[-3].string);
	char *ip_dst = (yyvsp[-1].string);
	if (ipv4_header_append(packet, ip_src, ip_dst, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
#line 2413 "parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 764 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-5].packet);
	char *ip_src = (yyvsp[-3].string);
	char *ip_dst = (yyvsp[-1].string);
	if (ipv6_header_append(packet, ip_src, ip_dst, &error))
		semantic_error(error);
	free(ip_src);
	free(ip_dst);
	(yyval.packet) = packet;
}
#line 2429 "parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 775 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-2].packet);
	if (gre_header_append(packet, &error))
		semantic_error(error);
	(yyval.packet) = packet;
}
#line 2441 "parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 782 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	struct packet *packet = (yyvsp[-3].packet);
	struct mpls_stack *mpls_stack = (yyvsp[-1].mpls_stack);

	if (mpls_header_append(packet, mpls_stack, &error))
		semantic_error(error);
	free(mpls_stack);
	(yyval.packet) = packet;
}
#line 2456 "parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 795 "parser.y" /* yacc.c:1646  */
    {
	(yyval.mpls_stack) = mpls_stack_new();
}
#line 2464 "parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 798 "parser.y" /* yacc.c:1646  */
    {
	if (mpls_stack_append((yyvsp[-1].mpls_stack), (yyvsp[0].mpls_stack_entry)))
		semantic_error("too many MPLS labels");
	(yyval.mpls_stack) = (yyvsp[-1].mpls_stack);
}
#line 2474 "parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 807 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	s64 label = (yyvsp[-8].integer);
	s64 traffic_class = (yyvsp[-5].integer);
	bool is_stack_bottom = (yyvsp[-3].integer);
	s64 ttl = (yyvsp[-1].integer);
	struct mpls mpls;

	if (new_mpls_stack_entry(label, traffic_class, is_stack_bottom, ttl,
				 &mpls, &error))
		semantic_error(error);
	(yyval.mpls_stack_entry) = mpls;
}
#line 2492 "parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 823 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 2498 "parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 824 "parser.y" /* yacc.c:1646  */
    {
	if (strcmp((yyvsp[-2].string), "S") != 0)
		semantic_error("expected [S] for MPLS label stack bottom");
	free((yyvsp[-2].string));
	(yyval.integer) = 1;
}
#line 2509 "parser.c" /* yacc.c:1646  */
    break;

  case 49:
#line 833 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2515 "parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 837 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 2521 "parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 838 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2527 "parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 843 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= 0;
	(yyval.tcp_sequence_info).protocol		= IPPROTO_TCP;
}
#line 2537 "parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 848 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info).start_sequence	= 0;
	(yyval.tcp_sequence_info).payload_bytes	= (yyvsp[-2].integer);
	(yyval.tcp_sequence_info).protocol		= IPPROTO_UDP;
}
#line 2547 "parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 853 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_sequence_info) = (yyvsp[-1].tcp_sequence_info);
}
#line 2555 "parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 859 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = -1; }
#line 2561 "parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 860 "parser.y" /* yacc.c:1646  */
    { (yyval.integer) = (yyvsp[0].integer); }
#line 2567 "parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 864 "parser.y" /* yacc.c:1646  */
    { (yyval.direction) = DIRECTION_INBOUND;  current_script_line = yylineno; }
#line 2573 "parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 865 "parser.y" /* yacc.c:1646  */
    { (yyval.direction) = DIRECTION_OUTBOUND; current_script_line = yylineno; }
#line 2579 "parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 869 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_NOCHECK; }
#line 2585 "parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 870 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = (yyvsp[-1].ip_ecn); }
#line 2591 "parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 874 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_NONE; }
#line 2597 "parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 875 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_ECT0; }
#line 2603 "parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 876 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_ECT1; }
#line 2609 "parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 877 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_ECT01; }
#line 2615 "parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 878 "parser.y" /* yacc.c:1646  */
    { (yyval.ip_ecn) = ECN_CE; }
#line 2621 "parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 882 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2627 "parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 883 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup("."); }
#line 2633 "parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 884 "parser.y" /* yacc.c:1646  */
    { asprintf(&((yyval.string)), "%s.", (yyvsp[-1].string)); free((yyvsp[-1].string)); }
#line 2639 "parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 885 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 2645 "parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 889 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u32((yyvsp[-5].integer))) {
		semantic_error("TCP start sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[-3].integer))) {
		semantic_error("TCP end sequence number out of range");
	}
	if (!is_valid_u16((yyvsp[-1].integer))) {
		semantic_error("TCP payload size out of range");
	}
	if ((yyvsp[-3].integer) != ((yyvsp[-5].integer) +(yyvsp[-1].integer))) {
		semantic_error("inconsistent TCP sequence numbers and "
			       "payload size");
	}
	(yyval.tcp_sequence_info).start_sequence = (yyvsp[-5].integer);
	(yyval.tcp_sequence_info).payload_bytes = (yyvsp[-1].integer);
	(yyval.tcp_sequence_info).protocol = IPPROTO_TCP;
}
#line 2668 "parser.c" /* yacc.c:1646  */
    break;

  case 71:
#line 910 "parser.y" /* yacc.c:1646  */
    { (yyval.sequence_number) = 0; }
#line 2674 "parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 911 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("TCP ack sequence number out of range");
	}
	(yyval.sequence_number) = (yyvsp[0].integer);
}
#line 2685 "parser.c" /* yacc.c:1646  */
    break;

  case 73:
#line 920 "parser.y" /* yacc.c:1646  */
    { (yyval.window) = -1; }
#line 2691 "parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 921 "parser.y" /* yacc.c:1646  */
    {
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("TCP window value out of range");
	}
	(yyval.window) = (yyvsp[0].integer);
}
#line 2702 "parser.c" /* yacc.c:1646  */
    break;

  case 75:
#line 930 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = tcp_options_new(); }
#line 2708 "parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 931 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = (yyvsp[-1].tcp_options); }
#line 2714 "parser.c" /* yacc.c:1646  */
    break;

  case 77:
#line 932 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_options) = NULL; /* FLAG_OPTIONS_NOCHECK */ }
#line 2720 "parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 936 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_options) = tcp_options_new();
	if (tcp_options_append((yyval.tcp_options), (yyvsp[0].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
#line 2731 "parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 942 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_options) = (yyvsp[-2].tcp_options);
	if (tcp_options_append((yyval.tcp_options), (yyvsp[0].tcp_option))) {
		semantic_error("TCP option list too long");
	}
}
#line 2742 "parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 951 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(""); }
#line 2748 "parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 952 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2754 "parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 956 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(yytext); }
#line 2760 "parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 957 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = strdup(yytext); }
#line 2766 "parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 961 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_NOP, 1); }
#line 2772 "parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 962 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = tcp_option_new(TCPOPT_EOL, 1); }
#line 2778 "parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 963 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_MAXSEG, TCPOLEN_MAXSEG);
	if (!is_valid_u16((yyvsp[0].integer))) {
		semantic_error("mss value out of range");
	}
	(yyval.tcp_option)->data.mss.bytes = htons((yyvsp[0].integer));
}
#line 2790 "parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 970 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_WINDOW, TCPOLEN_WINDOW);
	if (!is_valid_u8((yyvsp[0].integer))) {
		semantic_error("window scale shift count out of range");
	}
	(yyval.tcp_option)->data.window_scale.shift_count = (yyvsp[0].integer);
}
#line 2802 "parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 977 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK_PERMITTED,
				    TCPOLEN_SACK_PERMITTED);
}
#line 2811 "parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 981 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = (yyvsp[0].tcp_option);
}
#line 2819 "parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 984 "parser.y" /* yacc.c:1646  */
    {
	u32 val, ecr;
	(yyval.tcp_option) = tcp_option_new(TCPOPT_TIMESTAMP, TCPOLEN_TIMESTAMP);
	if (!is_valid_u32((yyvsp[-2].integer))) {
		semantic_error("ts val out of range");
	}
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("ecr val out of range");
	}
	val = (yyvsp[-2].integer);
	ecr = (yyvsp[0].integer);
	(yyval.tcp_option)->data.time_stamp.val = htonl(val);
	(yyval.tcp_option)->data.time_stamp.ecr = htonl(ecr);
}
#line 2838 "parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 998 "parser.y" /* yacc.c:1646  */
    {
	char *error = NULL;
	(yyval.tcp_option) = new_tcp_fast_open_option((yyvsp[0].string), &error);
	free((yyvsp[0].string));
	if ((yyval.tcp_option) == NULL) {
		assert(error != NULL);
		semantic_error(error);
		free(error);
	}
}
#line 2853 "parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1011 "parser.y" /* yacc.c:1646  */
    { (yyval.tcp_option) = (yyvsp[0].tcp_option); }
#line 2859 "parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1012 "parser.y" /* yacc.c:1646  */
    {
	const int list_block_bytes =  (yyvsp[-1].tcp_option)->length - 2;
	assert(list_block_bytes > 0);
	assert((list_block_bytes % sizeof(struct sack_block)) == 0);
	const int num_blocks = list_block_bytes / sizeof(struct sack_block);
	/* Append this SACK block to the end of the array of blocks. */
	memcpy((yyvsp[-1].tcp_option)->data.sack.block + num_blocks, (yyvsp[0].tcp_option)->data.sack.block,
		sizeof(struct sack_block));
	(yyvsp[-1].tcp_option)->length += sizeof(struct sack_block);
	free((yyvsp[0].tcp_option));
	(yyval.tcp_option) = (yyvsp[-1].tcp_option);
}
#line 2876 "parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1027 "parser.y" /* yacc.c:1646  */
    {
	(yyval.tcp_option) = tcp_option_new(TCPOPT_SACK, 2 + sizeof(struct sack_block));
	if (!is_valid_u32((yyvsp[-2].integer))) {
		semantic_error("TCP SACK left sequence number out of range");
	}
	if (!is_valid_u32((yyvsp[0].integer))) {
		semantic_error("TCP SACK right sequence number out of range");
	}
	(yyval.tcp_option)->data.sack.block[0].left = htonl((yyvsp[-2].integer));
	(yyval.tcp_option)->data.sack.block[0].right = htonl((yyvsp[0].integer));
}
#line 2892 "parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1042 "parser.y" /* yacc.c:1646  */
    {
	(yyval.syscall) = calloc(1, sizeof(struct syscall_spec));
	(yyval.syscall)->end_usecs	= (yyvsp[-6].time_usecs);
	(yyval.syscall)->name	= (yyvsp[-5].string);
	(yyval.syscall)->arguments	= (yyvsp[-4].expression_list);
	(yyval.syscall)->result	= (yyvsp[-2].expression);
	(yyval.syscall)->error	= (yyvsp[-1].errno_info);
	(yyval.syscall)->note	= (yyvsp[0].string);
}
#line 2906 "parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1054 "parser.y" /* yacc.c:1646  */
    { (yyval.time_usecs) = SYSCALL_NON_BLOCKING; }
#line 2912 "parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1055 "parser.y" /* yacc.c:1646  */
    { (yyval.time_usecs) = (yyvsp[0].time_usecs); }
#line 2918 "parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1059 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); current_script_line = yylineno; }
#line 2924 "parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1063 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = NULL; }
#line 2930 "parser.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1064 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = (yyvsp[-1].expression_list); }
#line 2936 "parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1068 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = new_expression_list((yyvsp[0].expression)); }
#line 2942 "parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1069 "parser.y" /* yacc.c:1646  */
    { (yyval.expression_list) = (yyvsp[-2].expression_list); expression_list_append((yyvsp[-2].expression_list), (yyvsp[0].expression)); }
#line 2948 "parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1073 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_ELLIPSIS);
}
#line 2956 "parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1076 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2962 "parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1077 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 2968 "parser.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1078 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_WORD);
	(yyval.expression)->value.string = (yyvsp[0].string);
}
#line 2977 "parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1082 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.string = (yyvsp[0].string);
	(yyval.expression)->format = "\"%s\"";
}
#line 2987 "parser.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1087 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_STRING);
	(yyval.expression)->value.string = (yyvsp[-1].string);
	(yyval.expression)->format = "\"%s\"...";
}
#line 2997 "parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1092 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3005 "parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1095 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3013 "parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1098 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3021 "parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1101 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3029 "parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1104 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3037 "parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1107 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3045 "parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1110 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3053 "parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1113 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = (yyvsp[0].expression);
}
#line 3061 "parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1119 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_integer_expression((yyvsp[0].integer), "%ld");
}
#line 3069 "parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1125 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_integer_expression((yyvsp[0].integer), "%#lx");
}
#line 3077 "parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1131 "parser.y" /* yacc.c:1646  */
    {       /* bitwise OR */
	(yyval.expression) = new_expression(EXPR_BINARY);
	struct binary_expression *binary =
			  malloc(sizeof(struct binary_expression));
	binary->op = strdup("|");
	binary->lhs = (yyvsp[-2].expression);
	binary->rhs = (yyvsp[0].expression);
	(yyval.expression)->value.binary = binary;
}
#line 3091 "parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1143 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = NULL;
}
#line 3100 "parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1147 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LIST);
	(yyval.expression)->value.list = (yyvsp[-1].expression_list);
}
#line 3109 "parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1154 "parser.y" /* yacc.c:1646  */
    {
	__be32 ip_address = inet_addr((yyvsp[-1].string));
	(yyval.expression) = new_integer_expression(ip_address, "%#lx");
}
#line 3118 "parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1163 "parser.y" /* yacc.c:1646  */
    {
	if (strcmp((yyvsp[-15].string), "AF_INET") == 0) {
		struct sockaddr_in *ipv4 = malloc(sizeof(struct sockaddr_in));
		memset(ipv4, 0, sizeof(*ipv4));
		ipv4->sin_family = AF_INET;
		ipv4->sin_port = htons((yyvsp[-9].integer));
		if (inet_pton(AF_INET, (yyvsp[-2].string), &ipv4->sin_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV4);
			(yyval.expression)->value.socket_address_ipv4 = ipv4;
		} else {
			free(ipv4);
			semantic_error("invalid IPv4 address");
		}
	} else if (strcmp((yyvsp[-15].string), "AF_INET6") == 0) {
		struct sockaddr_in6 *ipv6 = malloc(sizeof(struct sockaddr_in6));
		memset(ipv6, 0, sizeof(*ipv6));
		ipv6->sin6_family = AF_INET6;
		ipv6->sin6_port = htons((yyvsp[-9].integer));
		if (inet_pton(AF_INET6, (yyvsp[-2].string), &ipv6->sin6_addr) == 1) {
			(yyval.expression) = new_expression(EXPR_SOCKET_ADDRESS_IPV6);
			(yyval.expression)->value.socket_address_ipv6 = ipv6;
		} else {
			free(ipv6);
			semantic_error("invalid IPv6 address");
		}
	}
}
#line 3150 "parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1195 "parser.y" /* yacc.c:1646  */
    {
	struct msghdr_expr *msg_expr = calloc(1, sizeof(struct msghdr_expr));
	(yyval.expression) = new_expression(EXPR_MSGHDR);
	(yyval.expression)->value.msghdr = msg_expr;
	msg_expr->msg_name	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_namelen	= new_expression(EXPR_ELLIPSIS);
	msg_expr->msg_iov	= (yyvsp[-5].expression);
	msg_expr->msg_iovlen	= (yyvsp[-8].expression);
	msg_expr->msg_flags	= (yyvsp[-1].expression);
	/* TODO(ncardwell): msg_control, msg_controllen */
}
#line 3166 "parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1209 "parser.y" /* yacc.c:1646  */
    {
	struct iovec_expr *iov_expr = calloc(1, sizeof(struct iovec_expr));
	(yyval.expression) = new_expression(EXPR_IOVEC);
	(yyval.expression)->value.iovec = iov_expr;
	iov_expr->iov_base = new_expression(EXPR_ELLIPSIS);
	iov_expr->iov_len = (yyvsp[-1].expression);
}
#line 3178 "parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1219 "parser.y" /* yacc.c:1646  */
    {
	struct pollfd_expr *pollfd_expr = calloc(1, sizeof(struct pollfd_expr));
	(yyval.expression) = new_expression(EXPR_POLLFD);
	(yyval.expression)->value.pollfd = pollfd_expr;
	pollfd_expr->fd = (yyvsp[-6].expression);
	pollfd_expr->events = (yyvsp[-2].expression);
	pollfd_expr->revents = (yyvsp[-1].expression);
}
#line 3191 "parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1230 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = new_integer_expression(0, "%ld"); }
#line 3197 "parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1231 "parser.y" /* yacc.c:1646  */
    { (yyval.expression) = (yyvsp[0].expression); }
#line 3203 "parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1235 "parser.y" /* yacc.c:1646  */
    {
	(yyval.expression) = new_expression(EXPR_LINGER);
	(yyval.expression)->value.linger.l_onoff  = (yyvsp[-5].integer);
	(yyval.expression)->value.linger.l_linger = (yyvsp[-1].integer);
}
#line 3213 "parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1243 "parser.y" /* yacc.c:1646  */
    { (yyval.errno_info) = NULL; }
#line 3219 "parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1244 "parser.y" /* yacc.c:1646  */
    {
	(yyval.errno_info) = malloc(sizeof(struct errno_spec));
	(yyval.errno_info)->errno_macro = (yyvsp[-1].string);
	(yyval.errno_info)->strerror    = (yyvsp[0].string);
}
#line 3229 "parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1252 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = NULL; }
#line 3235 "parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1253 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3241 "parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1257 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[-1].string); }
#line 3247 "parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1261 "parser.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 3253 "parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1262 "parser.y" /* yacc.c:1646  */
    { asprintf(&((yyval.string)), "%s %s", (yyvsp[-1].string), (yyvsp[0].string)); free((yyvsp[-1].string)); free((yyvsp[0].string)); }
#line 3259 "parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1266 "parser.y" /* yacc.c:1646  */
    {
	(yyval.command) = malloc(sizeof(struct command_spec));
	(yyval.command)->command_line = (yyvsp[0].string);
	current_script_line = yylineno;
}
#line 3269 "parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1274 "parser.y" /* yacc.c:1646  */
    {
	(yyval.code) = calloc(1, sizeof(struct code_spec));
	(yyval.code)->text = (yyvsp[0].string);
	current_script_line = yylineno;
 }
#line 3279 "parser.c" /* yacc.c:1646  */
    break;


#line 3283 "parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
